extern char *malloc(), *realloc();

# line 6 "gram.y"
#include <stdio.h>
#include <math.h>
#include "art.h"
#include "macro.h"

extern object	*objectinit(),
		*compinit(),
		*csginit(),
		*getcsgobj(),
		*getcsgexp();

extern symbol	*lookup();

extern light	*lightinit();
extern texture	*textureinit();
extern wlist	*waveinit();
extern cmap	*mapinit();

extern attr	*astackp;
extern mats	*mstackp;

extern object	*oblist;
extern light	*lights;

extern vector	org, up;

extern matrix	trans;
extern float	focallength;

extern char	*title;
extern int	maxhitlevel, raysperpix, pixelgrid;
extern long	filetype;

extern colour	backcol;

extern float	fogfactor, rfactor;
extern colour	hazecolour;

extern float	sourceradius;
extern float	falloff;
extern float	ri;

extern float	screenx, screeny;
extern int	maxtreedepth;
extern int	perspective;

extern int	frameno;

extern float		eval_fexpr();
extern int		eval_iexpr();
extern expression	*get_expr(), *get_varexpr();

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif

static int	objdefined = FALSE;
static int	fieldtype;

extern symbol	**ostackp;


# line 69 "gram.y"
typedef union {
	object		*y_obj;
	vector		*y_pnt;
	details		*y_det;
	char		*y_str;
	eqn		*y_eqn;
	term		*y_trm;
	expression	*y_exp;
	symbol		*y_sym;
	csgnode		*y_csg;
	float		y_flt;
	int		y_int;
} YYSTYPE;
# define CSG 257
# define COMPOSITE 258
# define OBJECT_TYPE 259
# define FLOAT 260
# define INTEGER 261
# define FILETYPE 262
# define OPTION 263
# define NAME 264
# define LBRACE 265
# define RBRACE 266
# define LP 267
# define RP 268
# define RADIUS 269
# define RADII 270
# define COLOUR 271
# define CENTER 272
# define VERTEX 273
# define COMMA 274
# define PCENT 275
# define MATERIAL 276
# define REFI 277
# define MINUS 278
# define AMBIENT 279
# define INTENSITY 280
# define LOCATION 281
# define DOLS 282
# define EQUATION 283
# define OFFFILE 284
# define BASE 285
# define TOP 286
# define CONST 287
# define COEFFS 288
# define SCALE 289
# define ROTATE 290
# define TRANSLATE 291
# define TITLE 292
# define REFLECTANCE 293
# define DOT 294
# define ON 295
# define OFF 296
# define LOOKAT 297
# define FIELDOFVIEW 298
# define TRANSPARENCY 299
# define RAYSPERPIXEL 300
# define BACKGROUND 301
# define SIZE 302
# define MAXHITLEVEL 303
# define OUTPUT 304
# define ORDER 305
# define ABSORPTION 306
# define VREF1 307
# define VREF2 308
# define NUMRAYS 309
# define OBJECT 310
# define TEXTURE 311
# define DIRECTION 312
# define ANGLE 313
# define UP 314
# define TWENTYFIVEBIT 315
# define RANGE 316
# define MAP 317
# define BLENDCOLOR 318
# define SCALEFACTORS 319
# define VORTFILE 320
# define HAZECOLOUR 321
# define FOGFACTOR 322
# define RFACTOR 323
# define FALLOFF 324
# define QUOTE 325
# define REPEAT 326
# define SHADOWS 327
# define COLOURFILE 328
# define VNORMALFILE 329
# define SCALEFACTOR 330
# define SOURCE 331
# define AMPLITUDE 332
# define WAVELENGTH 333
# define PHASE 334
# define TURBULENCE 335
# define SQUEEZE 336
# define DAMPING 337
# define SOURCERADIUS 338
# define NORMAL 339
# define COMPLEXVERTEX 340
# define SCREENSIZE 341
# define MAXTREEDEPTH 342
# define BLEND 343
# define COLOURMAP 344
# define MAPVALUES 345
# define PIXELGRID 346
# define RI 347
# define COLOURBLEND 348
# define NORMALFILE 349
# define BEAMDISTRIBUTION 350
# define INSIDEANGLE 351
# define PROJECTION 352
# define PERSPECTIVE 353
# define ORTHOGRAPHIC 354
# define STRIP 355
# define VCOLOURFILE 356
# define TRANSFORM 357
# define MINDIST 358
# define CLIPVOLUME 359
# define HEIGHTFIELD 360
# define FRAMENO 361
# define BLOCKSIZE 362
# define GAPCOLOUR 363
# define GAPSIZE 364
# define PLUS 365
# define MULT 366
# define DIV 367
# define POWER 368
# define UMINUS 369
# define EQUALS 370
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 171
# define YYLAST 1487
int yyact[]={

   163,   247,   330,   365,   153,   154,   348,   262,    71,    78,
    79,    80,    81,    82,    83,    84,   470,    96,    97,   105,
    90,    91,   222,    93,    94,   172,   141,   142,   152,   133,
   134,   231,   106,    29,    86,    87,    85,   180,   112,   113,
   114,   118,   119,   369,   121,   122,   123,   124,   409,   268,
   468,   370,   187,   188,   152,   132,   186,   150,   144,   185,
   111,   140,   109,   108,   107,   145,   146,   147,   148,   149,
   389,    92,   466,    89,    88,   101,   152,   351,   156,   187,
   188,   402,   352,   186,   464,   300,   185,   440,   152,   159,
   160,   103,   102,    34,    32,    33,   322,   260,   102,   152,
   101,   100,   100,   459,    98,   171,   206,   280,   174,   175,
   176,   177,   178,   152,   270,   151,   153,   154,   181,   189,
   204,   201,   205,   207,   209,   104,   462,   170,   118,   460,
   152,   168,   456,   152,   208,   212,   152,    99,    98,   210,
   211,   151,   153,   154,   395,   216,   455,   203,   202,   166,
   152,   217,   218,   219,   220,   221,   127,   152,   223,   224,
   110,    35,   227,   151,   153,   154,   215,   214,   213,   454,
   450,   103,   105,   246,   152,   151,   153,   154,    99,   152,
   253,   118,   277,   256,   259,   436,   151,   153,   154,   257,
   269,   264,   118,   229,   267,   152,   155,   143,   131,   237,
   151,   153,   154,   130,   271,   272,   273,   274,   275,   276,
   129,   278,   279,   128,   281,   282,   283,   151,   153,   154,
   151,   153,   154,   151,   153,   154,   287,   288,   449,   290,
   126,   125,   152,   435,    70,   120,   448,   151,   153,   154,
   152,   245,   244,   152,   151,   153,   154,   139,    95,   310,
   311,   312,   313,   314,   138,   444,   316,   394,   318,   152,
   443,   151,   153,   154,   152,   167,   151,   153,   154,   349,
   425,   331,   165,   442,   116,   237,   297,   152,   393,   307,
   152,   137,   151,   153,   154,   338,   339,   340,   349,   115,
   343,   327,   136,   298,   424,     5,   239,   429,     3,   135,
   328,   152,   422,   423,   152,   169,   354,   152,     4,     2,
   355,     1,   152,   329,   421,   376,   361,   335,   363,   151,
   153,   154,   191,   366,   152,   367,   368,   151,   153,   154,
   151,   153,   154,   372,   373,   374,   297,   382,   383,   418,
   419,   345,   386,   387,   152,   388,   151,   153,   154,   152,
   184,   151,   153,   154,     0,     0,   347,   348,   396,   397,
   398,   399,     0,   400,   151,   153,   154,   151,   153,   154,
     0,   331,   406,   405,     0,   347,   348,   328,     0,   410,
   411,   412,   413,     0,     0,   416,   417,     0,   151,   153,
   154,   151,   153,   154,   151,   153,   154,   420,     0,   151,
   153,   154,   426,   427,     0,   428,     0,     0,   430,   431,
   432,   151,   153,   154,   295,   433,   434,   192,     0,     0,
   437,     0,    72,    73,   439,     0,    76,     0,   265,   117,
   441,   151,   153,   154,   243,   200,   151,   153,   154,   235,
    77,     0,   152,   445,   446,   447,   364,     0,     0,   451,
   452,   453,   307,     0,   415,   254,   457,   458,   152,     0,
     0,   461,   263,   463,     0,   465,     0,   467,     0,   469,
    27,    26,    25,     0,     0,   162,    61,    28,     0,     0,
     0,   266,    38,    39,    56,    36,    40,    75,   304,    54,
     0,     0,    57,     0,    63,   346,    41,    48,    46,    45,
    44,    43,    34,    32,    33,     6,    58,   349,     0,     0,
    18,     7,    59,    10,    19,     0,    20,    21,    37,    60,
   403,   292,    64,    74,    62,    69,    68,    17,    16,   151,
   153,   154,   152,     0,    11,    12,    13,    22,     0,    31,
    55,    51,    52,     0,   414,   151,   153,   154,   152,   408,
     0,    14,     0,   152,     8,     9,     0,   407,     0,    15,
    23,   152,    53,    66,    65,    24,     0,   152,    49,    50,
    35,    67,    42,    47,   302,   303,   299,     0,   404,     0,
    61,   301,   152,     0,   300,     0,    38,    39,    56,    36,
    40,     0,     0,    54,   347,   348,    57,     0,    63,     0,
    41,    48,    46,    45,    44,    43,    34,    32,    33,     0,
    58,   194,   195,   196,   197,   198,    59,     0,     0,   151,
   153,   154,    37,    60,   356,     0,    64,     0,    62,    69,
    68,   308,     0,     0,   152,   151,   153,   154,   438,     0,
   151,   153,   154,     0,    55,    51,    52,     0,   151,   153,
   154,     0,     0,   401,   151,   153,   154,   152,     0,     0,
     0,    34,    32,    33,   233,     0,    53,    66,    65,   151,
   153,   154,    49,    50,    35,    67,    42,    47,   242,   241,
   240,     0,   385,     0,    61,   234,   152,   294,   291,     0,
    38,    39,    56,    36,    40,     0,     0,    54,   309,     0,
    57,     0,    63,     0,    41,    48,    46,    45,    44,    43,
    34,    32,    33,     0,    58,   350,     0,     0,     0,   353,
    59,   151,   153,   154,     0,   206,    37,    60,     0,    35,
    64,     0,    62,    69,    68,     0,     0,     0,     0,   204,
   201,   205,   207,   209,   151,   153,   154,     0,    55,    51,
    52,   384,     0,   208,   212,   152,   371,     0,   210,   211,
   152,     0,   390,   391,   392,   362,   203,   202,   233,   152,
    53,    66,    65,   151,   153,   154,    49,    50,    35,    67,
    42,    47,   242,   241,   240,   215,   214,   213,    61,   234,
     0,   236,     0,     0,    38,    39,    56,    36,    40,     0,
     0,    54,     0,     0,    57,     0,    63,     0,    41,    48,
    46,    45,    44,    43,    34,    32,    33,     0,    58,     0,
     0,     0,     0,     0,    59,     0,     0,     0,   360,     0,
    37,    60,   152,     0,    64,     0,    62,    69,    68,     0,
     0,     0,   151,   153,   154,     0,   359,   151,   153,   154,
   152,   358,    55,    51,    52,   152,   151,   153,   154,     0,
    72,    73,   357,     0,    76,   344,   152,   117,     0,   152,
     0,     0,   233,   342,    53,    66,    65,   152,    77,     0,
    49,    50,    35,    67,    42,    47,    61,   234,     0,   323,
     0,     0,    38,    39,    56,    36,    40,    72,    73,    54,
     0,    76,    57,     0,    63,     0,    41,    48,    46,    45,
    44,    43,    34,    32,    33,    77,    58,     0,     0,   151,
   153,   154,    59,     0,     0,    75,   341,     0,    37,    60,
   152,     0,    64,     0,    62,    69,    68,   151,   153,   154,
     0,     0,   151,   153,   154,   337,     0,     0,   164,   152,
    55,    51,    52,   151,   153,   154,   151,   153,   154,     0,
     0,    74,    75,   336,   151,   153,   154,   152,     0,     0,
   233,   334,    53,    66,    65,   152,     0,     0,    49,    50,
    35,    67,    42,    47,    61,   234,     0,   293,     0,     0,
    38,    39,    56,    36,    40,    72,    73,    54,    74,    76,
    57,     0,    63,     0,    41,    48,    46,    45,    44,    43,
    34,    32,    33,    77,    58,     0,     0,   151,   153,   154,
    59,     0,     0,     0,   333,     0,    37,    60,   152,     0,
    64,     0,    62,    69,    68,     0,   151,   153,   154,     0,
     0,     0,     0,     0,     0,     0,     0,   332,    55,    51,
    52,   152,     0,     0,   151,   153,   154,     0,     0,     0,
    75,   325,   151,   153,   154,   152,     0,     0,   233,     0,
    53,    66,    65,     0,     0,     0,    49,    50,    35,    67,
    42,    47,    61,   234,     0,   230,     0,     0,    38,    39,
    56,    36,    40,     0,   258,    54,    74,     0,    57,     0,
    63,     0,    41,    48,    46,    45,    44,    43,    34,    32,
    33,     0,    58,     0,     0,   151,   153,   154,    59,   187,
   188,     0,     0,   186,    37,    60,   185,   321,    64,   324,
    62,    69,    68,   152,     0,   326,     0,   260,   151,   153,
   154,     0,     0,     0,     0,   317,    55,    51,    52,   152,
     0,     0,   151,   153,   154,     0,     0,   315,    34,    32,
    33,   152,     0,   305,   199,     0,   233,   152,    53,    66,
    65,   206,     0,     0,    49,    50,    35,    67,    42,    47,
   289,   232,     0,    30,   152,   204,   201,   205,   207,   209,
   286,     0,     0,   285,   152,     0,     0,   152,   284,   208,
   212,   206,   152,   255,   210,   211,   252,   152,     0,     0,
   152,     0,   203,   202,   183,   204,   201,   205,   207,   209,
   151,   153,   154,   251,   259,     0,    35,   152,   173,   208,
   212,   215,   214,   213,   210,   211,   151,   153,   154,     0,
   250,   152,   203,   202,   152,     0,     0,   249,   151,   153,
   154,   152,     0,   248,   151,   153,   154,   152,     0,     0,
   228,   215,   214,   213,   152,   226,     0,     0,     0,   152,
   225,   151,   153,   154,   152,   193,     0,     0,     0,   152,
   261,   151,   153,   154,   151,   153,   154,     0,   190,   151,
   153,   154,   152,     0,   151,   153,   154,   151,   153,   154,
   182,     0,     0,   179,   152,   308,   161,   152,     0,   158,
   152,     0,   306,   152,   151,   153,   154,   157,   375,     0,
     0,   152,     0,     0,   377,     0,     0,     0,   151,   153,
   154,   151,   153,   154,     0,    34,    32,    33,   151,   153,
   154,     0,     0,     0,   151,   153,   154,     0,     0,   238,
     0,   151,   153,   154,   319,   320,   151,   153,   154,     0,
     0,   151,   153,   154,     0,     0,   151,   153,   154,     0,
     0,     0,   309,     0,     0,     0,     0,     0,     0,   151,
   153,   154,     0,     0,   379,   378,   380,     0,     0,   381,
     0,   151,   153,   154,   151,   153,   154,   151,   153,   154,
   151,   153,   154,    35,     0,     0,     0,     0,   151,   153,
   154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   238,   296,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   296 };
int yypact[]={

 -1000,   213, -1000, -1000, -1000, -1000,   -30,   735,   735,   735,
   735,   735,   735,   735,   735,  -259,  -261,  -193,  -194,   735,
   735,  -191,   735,   735,  -336,  -127,  -164,  -173,  -245, -1000,
 -1000,   735,  -203,  -204,  -205,  -105,  -207,   735,   735,   735,
   600,  -240,   -24,   735,   735,   735,   735,   -33,   -34,  -109,
   -51,   -54,   -61,   -66,   735,  -266, -1000, -1000, -1000, -1000,
   735,  -269,   -67,  -209,   735,   735,   735,   735,   735,  -210,
 -1000,   289, -1000, -1000, -1000,   -68, -1000,   735,  1043,   289,
   289,  1035,   289,   289,   289, -1000, -1000, -1000,   735,   735,
  1032,   289, -1000,   289,   289,   637, -1000, -1000, -1000,  -116,
 -1000,  -134, -1000,  -138,   735,  -277,   963,   735,   735,   735,
   735,   735,   289,   289,  1029,  -237, -1000,   735,  1026,  -208,
  -146,  1014,   289,   289,   289, -1000, -1000,   600, -1000, -1000,
 -1000, -1000,  1001, -1000, -1000,   637,   637,   637,   637,   637,
   289, -1000, -1000,   899,   735,   289,   289,   289,   289,   289,
   735,   735,   735,   735,   735,  -303, -1000,   735,   735,   996,
   991,   735, -1000,   986,   -71,   819, -1000,   525, -1000, -1000,
 -1000,   289,   735, -1000,   979,   973,   966,   949,   932,   735,
   600,   929,   735,  -181, -1000,  -208,  -361, -1000, -1000, -1000,
   735,   162,  -237,   735, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000,   -74,  -151,   735,   735,   735,   735,   735,   735,   -82,
   735,   735,  -158,   735,   735,   735,   924,   919,  -362,  -362,
 -1000, -1000, -1000,   289,   916,   735,   735,   906,   735,   423,
 -1000, -1000, -1000, -1000,   -92,   721, -1000, -1000, -1000, -1000,
  -161,  -163,  -167,   421,   317, -1000,   889,  1046,   735,   735,
   735,   735,   735,   883, -1000,   735,   871,   735,  -208,  -208,
  -208,   859,  -169,   623,   855, -1000,  -237,   787,   869, -1000,
   735,   289,   289,   773,   750,   697,   289, -1000,   289,   289,
 -1000,   289,   689,   671,   735,   735,   735,   652,   599,   735,
   591, -1000, -1000, -1000, -1000,   229, -1000, -1000, -1000,   -86,
  -182,   -92,   -93,  -189,   317,   735, -1000, -1000, -1000,   735,
   356,   588,   577,   572,   554,   735,   491,   735,   164,  -208,
  -208,  -365,   735, -1000,   735,   735, -1000, -1000, -1000,  -223,
 -1000,   482,   735,   735,   735,  1052,   735,   735,   477,   408,
   289,   735,   735,   289,   735,  -196, -1000,  -182,  -182,  -182,
    10, -1000, -1000,    -9,   289,  -121, -1000,   735,   735,   735,
   735,   289,   735,   379, -1000,  -184,   254,   289,   304, -1000,
   735,   735,   283,   289,   275, -1000, -1000,  -219,   735,   735,
   735,   735,   270,   180,   735,   735,    71,    66,   289, -1000,
  -360, -1000,  -360, -1000, -1000, -1000,    46,    34,    29,    26,
     2,   735,   735, -1000,   735, -1000,    23,   735,   735,   735,
   289,   289,   289,   289,   735,   735,   -35,   -83, -1000,   735,
   372, -1000, -1000,   735, -1000, -1000,   289,  -179,   289,   735,
   289,   289,    -1,   289,   289, -1000, -1000,   -14, -1000,   -19,
 -1000,   289,   735,   735,   735,   -38,   -46,  -104,   735,   735,
   735,   -99,  -128,  -142, -1000,   735,   735,  -165,  -145, -1000,
   735,  -148,   735,  -190,   735,  -202,   735,  -224,   735,  -250,
 -1000 };
int yypgo[]={

     0,     0,  1094,   350,   414,   242,   296,   293,   322,   289,
   274,   272,  1181,    49,   291,   475,    31,     1,   265,   317,
   315,   313,     2,   311,   309,   308,   305,   299,   292,   281,
   254,   248,   247,   241 };
int yyr1[]={

     0,    23,    23,    23,    23,    23,    24,    24,    24,    24,
    24,    24,    24,    24,    24,    24,    24,    24,    24,    24,
    24,    24,    24,    24,    24,    24,    24,     6,     6,     6,
    26,     6,    18,    18,    18,    18,    25,    25,    25,    25,
    17,    17,    17,    17,    11,    11,    11,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    27,
    12,    28,    12,    29,    12,    30,    12,    31,    12,    32,
    12,    12,    12,    12,    12,    12,    12,    12,    12,    12,
    12,    12,    12,    12,    15,    15,    15,    15,     8,     8,
     9,     9,    10,    10,    10,    16,    16,    16,    16,    13,
    13,    13,    14,    14,    14,    14,    14,    14,    14,    14,
    14,    14,    14,    14,    14,    14,    14,    21,    21,    22,
    19,    19,    20,    20,    20,    20,    20,     5,     5,     5,
     5,     7,    33,     7,     7,     4,     4,     4,     4,     4,
     4,     2,     2,     2,     2,     2,     2,     3,     3,     3,
     3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1 };
int yyr2[]={

     0,     1,     4,     5,     4,     5,     5,     5,     9,     5,
     5,    13,     5,     5,     5,     5,     5,     5,    17,    33,
    13,     5,     5,     5,     5,     5,     5,     9,     3,     9,
     1,    13,     1,     5,     5,     5,     7,     3,     3,    11,
     1,     5,     5,    13,     1,     5,     5,    17,     5,     5,
     9,    13,     5,    13,    11,    13,     5,     5,     5,     5,
     5,     9,     5,     5,     5,     5,    17,     5,     5,     1,
     7,     1,     7,     1,     7,     1,     7,     1,     7,     1,
     7,     5,     5,     5,    11,     7,    13,    17,     5,     5,
     5,     5,     5,    17,    11,     3,    11,     7,     3,     5,
     3,     7,    15,    11,    15,    13,    17,    17,    53,     1,
     5,     5,     5,     9,     5,     5,    13,     9,    13,     5,
     5,     5,     5,     9,     5,    13,    13,     3,     7,    11,
     1,     5,    17,     5,     5,     5,     5,     1,     5,     5,
     5,    11,     1,    15,    11,     3,     7,     7,     7,     7,
     3,     3,     5,     7,    15,     7,     7,     3,     3,     3,
    11,     3,     3,     3,     7,     3,     7,     7,     7,     7,
     5 };
int yychk[]={

 -1000,   -23,   -24,    -6,   -25,    -7,   292,   298,   341,   342,
   300,   321,   322,   323,   338,   346,   315,   314,   297,   301,
   303,   304,   324,   347,   352,   259,   258,   257,   264,   -16,
   -12,   326,   290,   291,   289,   357,   272,   305,   269,   270,
   273,   283,   359,   288,   287,   286,   285,   360,   284,   355,
   356,   328,   329,   349,   276,   327,   271,   279,   293,   299,
   306,   263,   311,   281,   309,   351,   350,   358,   313,   312,
   264,    -1,   260,   261,   361,   325,   264,   278,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   295,   295,   296,   267,   267,
    -1,    -1,   262,    -1,    -1,   -31,   353,   354,   265,   264,
   265,   264,   265,   264,   370,   264,    -1,   267,   267,   267,
   265,   267,    -1,    -1,    -1,    -9,   -10,   267,    -1,   282,
   259,    -1,    -1,    -1,    -1,   264,   264,   265,   264,   264,
   264,   264,    -1,   295,   296,   -27,   -28,   -29,   -30,   -32,
    -1,   295,   296,   264,   267,    -1,    -1,    -1,    -1,    -1,
   267,   365,   278,   366,   367,   264,    -1,   274,   274,    -1,
    -1,   274,   -15,    -1,   311,   -11,   265,   -18,   265,   -26,
   265,    -1,   302,   265,    -1,    -1,    -1,    -1,    -1,   274,
   274,    -1,   274,    -2,    -3,   267,   264,   260,   261,   265,
   274,    -8,    -9,   274,   -15,   -15,   -15,   -15,   -15,   265,
   -14,   317,   344,   343,   316,   318,   302,   319,   330,   320,
   335,   336,   331,   364,   363,   362,    -1,    -1,    -1,    -1,
    -1,    -1,   325,    -1,    -1,   274,   274,    -1,   274,   264,
   266,   -16,   -12,   347,   264,   -11,   266,   -16,   -12,    -6,
   259,   258,   257,   -18,    -5,   -33,    -1,   -17,   274,   274,
   274,   274,   274,    -1,   -10,   274,    -1,   370,    -2,   365,
   278,    -2,   368,   -11,    -1,   266,    -9,    -1,   -13,   264,
   265,    -1,    -1,    -1,    -1,    -1,    -1,   264,    -1,    -1,
   265,    -1,    -1,    -1,   274,   274,   274,    -1,    -1,   274,
    -1,   265,   -14,   266,   266,    -4,   -12,   -16,    -7,   259,
   267,   264,   257,   258,    -5,   274,   266,   -16,   259,   326,
    -1,    -1,    -1,    -1,    -1,   274,    -1,   274,    -1,    -2,
    -2,   268,   265,   266,   274,   274,   266,   -14,   -16,   -21,
   -22,    -1,   274,   274,   274,   -19,   274,   274,    -1,    -1,
    -1,   274,   274,    -1,   274,   -13,   266,   365,   366,   278,
    -4,   259,   264,    -4,    -1,    -1,   268,   274,   274,   274,
   274,    -1,   274,    -1,   282,   368,    -1,    -1,    -1,   266,
   274,   274,    -1,    -1,    -1,   266,   -20,   272,   333,   332,
   334,   337,    -1,    -1,   274,   274,    -1,    -1,    -1,   266,
    -4,    -4,    -4,   268,   266,   265,    -1,    -1,    -1,    -1,
    -1,   274,   265,   266,   274,   -22,    -1,   274,   274,   267,
    -1,    -1,    -1,    -1,   274,   274,    -1,    -1,   268,   274,
   -17,   268,   268,   274,   268,   268,    -1,    -1,    -1,   274,
    -1,    -1,    -1,    -1,    -1,   268,   268,    -1,   266,    -1,
   266,    -1,   274,   274,   274,    -1,    -1,    -1,   274,   274,
   274,    -1,    -1,    -1,   268,   274,   274,    -1,    -1,   268,
   274,    -1,   274,    -1,   274,    -1,   274,    -1,   274,    -1,
   266 };
int yydef[]={

     1,    -2,     2,     3,     4,     5,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    77,     0,    28,     0,     0,     0,    37,
    38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    69,    71,    73,    75,
    79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     6,     7,   161,   162,   163,     0,   165,     0,     0,     9,
    10,     0,    12,    13,    14,    15,    16,    17,     0,     0,
     0,    21,    22,    23,    24,     0,    25,    26,    44,     0,
    32,     0,    30,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    48,    49,     0,    52,   100,     0,     0,     0,
     0,     0,    56,    57,    58,    59,    60,     0,    62,    63,
    64,    65,     0,    67,    68,     0,     0,     0,     0,     0,
    81,    82,    83,     0,     0,    88,    89,    90,    91,    92,
     0,     0,     0,     0,     0,     0,   170,     0,     0,     0,
     0,     0,    78,    95,     0,     0,    44,     0,    32,   137,
   142,    36,     0,    40,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   151,     0,   157,   158,   159,    44,
     0,     0,    98,     0,    70,    72,    74,    76,    80,   109,
    85,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   166,   167,
   168,   169,   164,     8,     0,     0,     0,     0,     0,     0,
    27,    45,    46,    77,     0,     0,    29,    33,    34,    35,
    28,     0,     0,     0,     0,   137,     0,     0,     0,     0,
     0,     0,     0,    50,   101,     0,     0,     0,   152,     0,
     0,     0,     0,     0,     0,    61,    99,     0,     0,   112,
     0,   114,   115,     0,     0,     0,   119,   120,   121,   122,
   130,   124,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   109,    97,   141,   144,     0,   138,   139,   140,   145,
     0,   150,     0,     0,     0,     0,    39,    41,    42,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   155,
   156,   153,     0,    54,     0,     0,    84,   110,   111,     0,
   127,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    11,     0,     0,    20,     0,     0,    31,     0,     0,     0,
     0,   145,   150,     0,    86,     0,   105,     0,     0,     0,
     0,    51,     0,   103,    53,     0,     0,    55,     0,   113,
     0,     0,     0,   117,     0,   123,   131,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    94,    96,
   146,   147,   148,   149,   143,    40,     0,     0,     0,     0,
     0,     0,     0,   160,     0,   128,     0,     0,     0,     0,
   133,   134,   135,   136,     0,     0,     0,     0,    18,     0,
     0,   106,   107,     0,    47,   102,   104,     0,    66,     0,
   116,   118,     0,   125,   126,    87,    93,     0,    43,     0,
   154,   129,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   132,     0,     0,     0,     0,    19,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   108 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"CSG",	257,
	"COMPOSITE",	258,
	"OBJECT_TYPE",	259,
	"FLOAT",	260,
	"INTEGER",	261,
	"FILETYPE",	262,
	"OPTION",	263,
	"NAME",	264,
	"LBRACE",	265,
	"RBRACE",	266,
	"LP",	267,
	"RP",	268,
	"RADIUS",	269,
	"RADII",	270,
	"COLOUR",	271,
	"CENTER",	272,
	"VERTEX",	273,
	"COMMA",	274,
	"PCENT",	275,
	"MATERIAL",	276,
	"REFI",	277,
	"MINUS",	278,
	"AMBIENT",	279,
	"INTENSITY",	280,
	"LOCATION",	281,
	"DOLS",	282,
	"EQUATION",	283,
	"OFFFILE",	284,
	"BASE",	285,
	"TOP",	286,
	"CONST",	287,
	"COEFFS",	288,
	"SCALE",	289,
	"ROTATE",	290,
	"TRANSLATE",	291,
	"TITLE",	292,
	"REFLECTANCE",	293,
	"DOT",	294,
	"ON",	295,
	"OFF",	296,
	"LOOKAT",	297,
	"FIELDOFVIEW",	298,
	"TRANSPARENCY",	299,
	"RAYSPERPIXEL",	300,
	"BACKGROUND",	301,
	"SIZE",	302,
	"MAXHITLEVEL",	303,
	"OUTPUT",	304,
	"ORDER",	305,
	"ABSORPTION",	306,
	"VREF1",	307,
	"VREF2",	308,
	"NUMRAYS",	309,
	"OBJECT",	310,
	"TEXTURE",	311,
	"DIRECTION",	312,
	"ANGLE",	313,
	"UP",	314,
	"TWENTYFIVEBIT",	315,
	"RANGE",	316,
	"MAP",	317,
	"BLENDCOLOR",	318,
	"SCALEFACTORS",	319,
	"VORTFILE",	320,
	"HAZECOLOUR",	321,
	"FOGFACTOR",	322,
	"RFACTOR",	323,
	"FALLOFF",	324,
	"QUOTE",	325,
	"REPEAT",	326,
	"SHADOWS",	327,
	"COLOURFILE",	328,
	"VNORMALFILE",	329,
	"SCALEFACTOR",	330,
	"SOURCE",	331,
	"AMPLITUDE",	332,
	"WAVELENGTH",	333,
	"PHASE",	334,
	"TURBULENCE",	335,
	"SQUEEZE",	336,
	"DAMPING",	337,
	"SOURCERADIUS",	338,
	"NORMAL",	339,
	"COMPLEXVERTEX",	340,
	"SCREENSIZE",	341,
	"MAXTREEDEPTH",	342,
	"BLEND",	343,
	"COLOURMAP",	344,
	"MAPVALUES",	345,
	"PIXELGRID",	346,
	"RI",	347,
	"COLOURBLEND",	348,
	"NORMALFILE",	349,
	"BEAMDISTRIBUTION",	350,
	"INSIDEANGLE",	351,
	"PROJECTION",	352,
	"PERSPECTIVE",	353,
	"ORTHOGRAPHIC",	354,
	"STRIP",	355,
	"VCOLOURFILE",	356,
	"TRANSFORM",	357,
	"MINDIST",	358,
	"CLIPVOLUME",	359,
	"HEIGHTFIELD",	360,
	"FRAMENO",	361,
	"BLOCKSIZE",	362,
	"GAPCOLOUR",	363,
	"GAPSIZE",	364,
	"PLUS",	365,
	"MULT",	366,
	"DIV",	367,
	"POWER",	368,
	"UMINUS",	369,
	"EQUALS",	370,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"input : /* empty */",
	"input : input hitem",
	"input : input object",
	"input : input statement",
	"input : input definition",
	"hitem : TITLE NAME",
	"hitem : FIELDOFVIEW expr",
	"hitem : SCREENSIZE expr COMMA expr",
	"hitem : MAXTREEDEPTH expr",
	"hitem : RAYSPERPIXEL expr",
	"hitem : HAZECOLOUR expr COMMA expr COMMA expr",
	"hitem : FOGFACTOR expr",
	"hitem : RFACTOR expr",
	"hitem : SOURCERADIUS expr",
	"hitem : PIXELGRID ON",
	"hitem : TWENTYFIVEBIT ON",
	"hitem : TWENTYFIVEBIT OFF",
	"hitem : UP LP expr COMMA expr COMMA expr RP",
	"hitem : LOOKAT LP expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RP",
	"hitem : BACKGROUND expr COMMA expr COMMA expr",
	"hitem : MAXHITLEVEL expr",
	"hitem : OUTPUT FILETYPE",
	"hitem : FALLOFF expr",
	"hitem : RI expr",
	"hitem : PROJECTION PERSPECTIVE",
	"hitem : PROJECTION ORTHOGRAPHIC",
	"object : OBJECT_TYPE LBRACE body RBRACE",
	"object : OBJECT_TYPE",
	"object : COMPOSITE LBRACE compbody RBRACE",
	"object : CSG LBRACE",
	"object : CSG LBRACE csgbody csgexpr RBRACE",
	"compbody : /* empty */",
	"compbody : compbody transform",
	"compbody : compbody bodyitem",
	"compbody : compbody object",
	"statement : NAME EQUALS expr",
	"statement : transform",
	"statement : bodyitem",
	"statement : REPEAT expr LBRACE stlist RBRACE",
	"stlist : /* empty */",
	"stlist : stlist transform",
	"stlist : stlist OBJECT_TYPE",
	"stlist : stlist REPEAT expr LBRACE stlist RBRACE",
	"body : /* empty */",
	"body : body transform",
	"body : body bodyitem",
	"bodyitem : CENTER LP expr COMMA expr COMMA expr RP",
	"bodyitem : ORDER expr",
	"bodyitem : RADIUS expr",
	"bodyitem : RADII expr COMMA expr",
	"bodyitem : RADII expr COMMA expr COMMA expr",
	"bodyitem : VERTEX vbody",
	"bodyitem : EQUATION DOLS termlist EQUALS expr DOLS",
	"bodyitem : CLIPVOLUME OBJECT_TYPE LBRACE body RBRACE",
	"bodyitem : COEFFS expr COMMA expr COMMA expr",
	"bodyitem : CONST expr",
	"bodyitem : TOP expr",
	"bodyitem : BASE expr",
	"bodyitem : HEIGHTFIELD NAME",
	"bodyitem : OFFFILE NAME",
	"bodyitem : STRIP LBRACE vlist RBRACE",
	"bodyitem : VCOLOURFILE NAME",
	"bodyitem : COLOURFILE NAME",
	"bodyitem : VNORMALFILE NAME",
	"bodyitem : NORMALFILE NAME",
	"bodyitem : MATERIAL expr COMMA expr COMMA expr COMMA expr",
	"bodyitem : SHADOWS ON",
	"bodyitem : SHADOWS OFF",
	"bodyitem : COLOUR",
	"bodyitem : COLOUR variation",
	"bodyitem : AMBIENT",
	"bodyitem : AMBIENT variation",
	"bodyitem : REFLECTANCE",
	"bodyitem : REFLECTANCE variation",
	"bodyitem : TRANSPARENCY",
	"bodyitem : TRANSPARENCY variation",
	"bodyitem : RI",
	"bodyitem : RI variation",
	"bodyitem : ABSORPTION",
	"bodyitem : ABSORPTION variation",
	"bodyitem : ABSORPTION expr",
	"bodyitem : OPTION ON",
	"bodyitem : OPTION OFF",
	"bodyitem : TEXTURE NAME LBRACE texture_ops RBRACE",
	"bodyitem : TEXTURE NAME textitem",
	"bodyitem : NAME NAME SIZE expr COMMA expr",
	"bodyitem : LOCATION LP expr COMMA expr COMMA expr RP",
	"bodyitem : NUMRAYS expr",
	"bodyitem : INSIDEANGLE expr",
	"bodyitem : BEAMDISTRIBUTION expr",
	"bodyitem : MINDIST expr",
	"bodyitem : ANGLE expr",
	"bodyitem : DIRECTION LP expr COMMA expr COMMA expr RP",
	"variation : expr COMMA expr COMMA expr",
	"variation : expr",
	"variation : TEXTURE NAME LBRACE texture_ops RBRACE",
	"variation : TEXTURE NAME textitem",
	"vlist : vbody",
	"vlist : vlist vbody",
	"vbody : vitem",
	"vbody : vbody COMMA vitem",
	"vitem : LP expr COMMA expr COMMA expr RP",
	"vitem : expr COMMA expr COMMA expr",
	"vitem : expr COMMA expr COMMA expr COMMA expr",
	"transform : ROTATE LP expr COMMA expr RP",
	"transform : TRANSLATE LP expr COMMA expr COMMA expr RP",
	"transform : SCALE LP expr COMMA expr COMMA expr RP",
	"transform : TRANSFORM LBRACE expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RBRACE",
	"texture_ops : /* empty */",
	"texture_ops : texture_ops textitem",
	"texture_ops : texture_ops transform",
	"textitem : MAP NAME",
	"textitem : COLOURMAP LBRACE mbody RBRACE",
	"textitem : BLEND expr",
	"textitem : RANGE expr",
	"textitem : BLENDCOLOR expr COMMA expr COMMA expr",
	"textitem : SIZE expr COMMA expr",
	"textitem : SCALEFACTORS expr COMMA expr COMMA expr",
	"textitem : SCALEFACTOR expr",
	"textitem : VORTFILE NAME",
	"textitem : TURBULENCE expr",
	"textitem : SQUEEZE expr",
	"textitem : SOURCE LBRACE wbody RBRACE",
	"textitem : GAPSIZE expr",
	"textitem : GAPCOLOUR expr COMMA expr COMMA expr",
	"textitem : BLOCKSIZE expr COMMA expr COMMA expr",
	"mbody : mitem",
	"mbody : mbody COMMA mitem",
	"mitem : expr COMMA expr COMMA expr",
	"wbody : /* empty */",
	"wbody : wbody witem",
	"witem : CENTER LP expr COMMA expr COMMA expr RP",
	"witem : WAVELENGTH expr",
	"witem : AMPLITUDE expr",
	"witem : PHASE expr",
	"witem : DAMPING expr",
	"csgbody : /* empty */",
	"csgbody : csgbody bodyitem",
	"csgbody : csgbody transform",
	"csgbody : csgbody definition",
	"definition : OBJECT_TYPE NAME LBRACE body RBRACE",
	"definition : CSG NAME LBRACE",
	"definition : CSG NAME LBRACE csgbody csgexpr RBRACE",
	"definition : COMPOSITE NAME LBRACE compbody RBRACE",
	"csgexpr : OBJECT_TYPE",
	"csgexpr : csgexpr PLUS csgexpr",
	"csgexpr : csgexpr MULT csgexpr",
	"csgexpr : csgexpr MINUS csgexpr",
	"csgexpr : LP csgexpr RP",
	"csgexpr : NAME",
	"termlist : term",
	"termlist : termlist termlist",
	"termlist : LP termlist RP",
	"termlist : LP termlist RP POWER LBRACE expr RBRACE",
	"termlist : termlist PLUS termlist",
	"termlist : termlist MINUS termlist",
	"term : NAME",
	"term : FLOAT",
	"term : INTEGER",
	"term : NAME POWER LBRACE expr RBRACE",
	"expr : FLOAT",
	"expr : INTEGER",
	"expr : FRAMENO",
	"expr : QUOTE NAME QUOTE",
	"expr : NAME",
	"expr : expr PLUS expr",
	"expr : expr MINUS expr",
	"expr : expr MULT expr",
	"expr : expr DIV expr",
	"expr : MINUS expr",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 124 "gram.y"
{
		objdefined = FALSE;
	  } break;
case 3:
# line 129 "gram.y"
{
		object	*obj, *head;

		if ((head = objectinit(yypvt[-0].y_det->u.obj.sym, yypvt[-0].y_det->u.obj.det)) != (object *)NULL) {
			for (obj = head; obj->nxt != (object *)NULL; obj = obj->nxt)	
				;

			obj->nxt = oblist;
			oblist = head;
		}

		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 5:
# line 146 "gram.y"
{
		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 6:
# line 154 "gram.y"
{
		title = yypvt[-0].y_str;
	  } break;
case 7:
# line 158 "gram.y"
{
		float	val;

		val = eval_fexpr(yypvt[-0].y_exp);

		if (val == 0.0 || val == 360.0)
			fatal("art: idiotic angle in field of view.\n");

		focallength = focallength / tan(M_PI / 360.0 * val);
	  } break;
case 8:
# line 169 "gram.y"
{
		screenx = eval_fexpr(yypvt[-2].y_exp) / 2.0;
		screeny = eval_fexpr(yypvt[-0].y_exp) / 2.0;
	  } break;
case 9:
# line 174 "gram.y"
{
		maxtreedepth = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 10:
# line 178 "gram.y"
{
		raysperpix = eval_iexpr(yypvt[-0].y_exp);
		pixelgrid = (raysperpix > 1);
	  } break;
case 11:
# line 183 "gram.y"
{
		hazecolour.r = eval_fexpr(yypvt[-4].y_exp);
		hazecolour.g = eval_fexpr(yypvt[-2].y_exp);
		hazecolour.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 12:
# line 189 "gram.y"
{
		fogfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 13:
# line 193 "gram.y"
{
		rfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 14:
# line 197 "gram.y"
{
		sourceradius = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 15:
# line 201 "gram.y"
{
		pixelgrid = TRUE;
	  } break;
case 16:
# line 205 "gram.y"
{
		twentyfivebit(TRUE);
	  } break;
case 17:
# line 209 "gram.y"
{
		twentyfivebit(FALSE);
	  } break;
case 18:
# line 213 "gram.y"
{
		up.x = eval_fexpr(yypvt[-5].y_exp);
		up.y = eval_fexpr(yypvt[-3].y_exp);
		up.z = eval_fexpr(yypvt[-1].y_exp);
	  } break;
case 19:
# line 219 "gram.y"
{
		vector	t, u, s, eye;
		matrix	m, tmp;
		double	val, vy, vz, sinval, cosval;

		/*
		 * apply the twist
		 */
		val = eval_fexpr(yypvt[-1].y_exp) * M_PI / 180.0;
		sinval = sin(val);
		cosval = cos(val);
		mident4(m);
		m[0][0] = cosval;
		m[0][1] = -sinval;
		m[1][0] = sinval;
		m[1][1] = cosval;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		/*
		 * calculate the lookat
		 */
		eye.x = eval_fexpr(yypvt[-13].y_exp);
		eye.y = eval_fexpr(yypvt[-11].y_exp);
		eye.z = eval_fexpr(yypvt[-9].y_exp);

		t.x = eye.x - eval_fexpr(yypvt[-7].y_exp);
		t.y = eye.y - eval_fexpr(yypvt[-5].y_exp);
		t.z = eye.z - eval_fexpr(yypvt[-3].y_exp);

		u.x = up.x;
		u.y = up.y;
		u.z = up.z;

		normalise(t);

		normalise(u);

		vz = dprod(t, u);

		if (fabs(vz) >= 1.0)
			fatal("art: up vector and direction of view are the same.\n");

		vy = sqrt(1.0 - vz * vz);

		u.x = (u.x - vz * t.x) / vy;
		u.y = (u.y - vz * t.y) / vy;
		u.z = (u.z - vz * t.z) / vy;

		xprod(s, u, t);

		mident4(m);

		m[0][0] = s.x;
		m[0][1] = s.y;
		m[0][2] = s.z;

		m[1][0] = u.x;
		m[1][1] = u.y;
		m[1][2] = u.z;

		m[2][0] = t.x;
		m[2][1] = t.y;
		m[2][2] = t.z;

		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		mident4(m);
		m[3][0] = eye.x;
		m[3][1] = eye.y;
		m[3][2] = eye.z;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);
					/* set up initial trans data */
		mstackp->omused = TRUE;
		calctransforms(mstackp);
	  } break;
case 20:
# line 298 "gram.y"
{
		backcol.r = eval_fexpr(yypvt[-4].y_exp);
		backcol.g = eval_fexpr(yypvt[-2].y_exp);
		backcol.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 21:
# line 304 "gram.y"
{
		maxhitlevel = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 22:
# line 308 "gram.y"
{
		filetype = yypvt[-0].y_int;
	  } break;
case 23:
# line 312 "gram.y"
{
		falloff = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 24:
# line 316 "gram.y"
{
		ri = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 25:
# line 320 "gram.y"
{
		perspective = TRUE;
	  } break;
case 26:
# line 324 "gram.y"
{
		perspective = FALSE;
	  } break;
case 27:
# line 330 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 28:
# line 338 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-0].y_sym;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 29:
# line 346 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COMP_OBJ;
		yyval.y_det->u.obj.sym = (symbol *)NULL;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 30:
# line 354 "gram.y"
{
		ostackp++;
		*ostackp = (symbol *)NULL;
	  } break;
case 31:
# line 359 "gram.y"
{
		details	*d;
		symbol	*s;

		ostackp--;

		d = (details *)smalloc(sizeof(details));
		d->type = yypvt[-2].y_det->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		s = (symbol *)smalloc(sizeof(symbol));
		s->type = CSG_OBJ;
		s->u.det = d;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = s;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 32:
# line 384 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 33:
# line 388 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 34:
# line 393 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 35:
# line 398 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
	  } break;
case 36:
# line 405 "gram.y"
{
		defvar(yypvt[-2].y_str, yypvt[-0].y_exp);
	  } break;
case 37:
# line 409 "gram.y"
{
		switch (yypvt[-0].y_det->type) {
		case TRANSLATE:
			translate(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case SCALE:
			scale(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case ROTATE:
			rotate(yypvt[-0].y_det->u.rot.ang, yypvt[-0].y_det->u.rot.axis);
			break;
		case TRANSFORM:
			transform(*yypvt[-0].y_det->u.trans.m);
			free(yypvt[-0].y_det->u.trans.m);
			break;
		default:
			fatal("art: bad transform type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 38:
# line 431 "gram.y"
{
		surface	*s;

			/*
			 * don't want to change someone else's
			 * material properties
			 */
		if (objdefined) {
			s = (surface *)smalloc(sizeof(surface));
			*s = *astackp->s;
			astackp->s = s;
		} else
			s = astackp->s;

		switch (yypvt[-0].y_det->type) {
		case COLOUR:
			s->c.r = yypvt[-0].y_det->u.c.r;
			s->c.g = yypvt[-0].y_det->u.c.g;
			s->c.b = yypvt[-0].y_det->u.c.b;
			break;
		case AMBIENT:
			s->a.r = yypvt[-0].y_det->u.c.r;
			s->a.g = yypvt[-0].y_det->u.c.g;
			s->a.b = yypvt[-0].y_det->u.c.b;
			break;
		case TEXTURE:
			yypvt[-0].y_det->u.txt->nxt = astackp->txtlist;
			astackp->txtlist = yypvt[-0].y_det->u.txt;
			break;
		case MATERIAL:
			s->ri = yypvt[-0].y_det->u.mat.ri;
			s->kd = yypvt[-0].y_det->u.mat.kd;
			s->ks = yypvt[-0].y_det->u.mat.ks;
			s->ksexp = yypvt[-0].y_det->u.mat.ksexp;
			if (s->ri == 0.0)
				s->ri = 1.0;
			break;
		case REFLECTANCE:
			s->refl = yypvt[-0].y_det->u.c;
			break;
		case TRANSPARENCY:
			s->trans = yypvt[-0].y_det->u.c;
			break;
		case ABSORPTION:
			s->falloff = yypvt[-0].y_det->u.f;
			break;
		case ON:
			astackp->options |= yypvt[-0].y_det->u.i;
			break;
		case OFF:
			astackp->options &= ~yypvt[-0].y_det->u.i;
			break;
		case SHADOWS:
			astackp->s->shadows = yypvt[-0].y_det->u.i;
			break;
		default:
			fatal("art: bad statement type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 39:
# line 493 "gram.y"
{
		dorepeat(yypvt[-3].y_exp, yypvt[-1].y_det);
	  } break;
case 40:
# line 499 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 41:
# line 503 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 42:
# line 508 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = yypvt[-0].y_sym;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 43:
# line 516 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = REPEAT;
		yyval.y_det->u.rpt.expr = yypvt[-3].y_exp;
		yyval.y_det->u.rpt.stmt = yypvt[-1].y_det;
		yyval.y_det->nxt = yypvt[-5].y_det;
	  } break;
case 44:
# line 528 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 45:
# line 532 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 46:
# line 537 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 47:
# line 544 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 48:
# line 553 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ORDER;
		yyval.y_det->u.i = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 49:
# line 560 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADIUS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 50:
# line 567 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 51:
# line 575 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 52:
# line 584 "gram.y"
{
		if (yypvt[-0].y_det->nxt == (details *)NULL) {
			yypvt[-0].y_det->type = VERTEX;
			yyval.y_det = yypvt[-0].y_det;
		} else {
			yyval.y_det = (details *)smalloc(sizeof(details));
			yyval.y_det->type = COMPLEXVERTEX;
			yyval.y_det->u.det = yypvt[-0].y_det;
			yyval.y_det->nxt = (details *)NULL;
		}
	  } break;
case 53:
# line 596 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = EQUATION;
		yyval.y_det->u.t = (term *)smalloc(sizeof(term));
		yyval.y_det->u.t->coef = -eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->u.t->xp = 0;
		yyval.y_det->u.t->yp = 0;
		yyval.y_det->u.t->zp = 0;
		yyval.y_det->u.t->nxt = yypvt[-3].y_trm;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 54:
# line 608 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 55:
# line 616 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COEFFS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 56:
# line 625 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CONST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 57:
# line 632 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TOP;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 58:
# line 639 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BASE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 59:
# line 646 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = HEIGHTFIELD;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 60:
# line 653 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFFFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 61:
# line 660 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = STRIP;
		yyval.y_det->u.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 62:
# line 667 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VCOLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 63:
# line 674 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 64:
# line 681 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VNORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 65:
# line 688 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 66:
# line 695 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MATERIAL;
		yyval.y_det->u.mat.ri = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.mat.kd = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.mat.ks = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.mat.ksexp = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 67:
# line 705 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = TRUE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->shadows = TRUE;
	  } break;
case 68:
# line 714 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = FALSE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->shadows = FALSE;
	  } break;
case 69:
# line 722 "gram.y"
{ fieldtype = COLOUR; } break;
case 70:
# line 723 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 71:
# line 726 "gram.y"
{ fieldtype = AMBIENT; } break;
case 72:
# line 727 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 73:
# line 730 "gram.y"
{ fieldtype = REFLECTANCE; } break;
case 74:
# line 731 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 75:
# line 734 "gram.y"
{ fieldtype = TRANSPARENCY; } break;
case 76:
# line 735 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 77:
# line 738 "gram.y"
{ fieldtype = RI; } break;
case 78:
# line 739 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 79:
# line 742 "gram.y"
{ fieldtype = ABSORPTION; } break;
case 80:
# line 743 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 81:
# line 747 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ABSORPTION;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 82:
# line 754 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ON;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 83:
# line 761 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFF;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 84:
# line 768 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 85:
# line 775 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 86:
# line 782 "gram.y"
{
		details	*d1, *d2;

		d1 = (details *)smalloc(sizeof(details));
		d1->type = VORTFILE;
		d1->u.s = yypvt[-4].y_str;

		d2 = (details *)smalloc(sizeof(details));
		d2->type = SIZE;
		d2->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		d2->u.v.y = eval_fexpr(yypvt[-0].y_exp);

		d1->nxt = d2;
		d2->nxt = (details *)NULL;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit("tile", d1, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 87:
# line 803 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 88:
# line 812 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NUMRAYS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 89:
# line 819 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = INSIDEANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 90:
# line 826 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BEAMDISTRIBUTION;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 91:
# line 833 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MINDIST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 92:
# line 840 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 93:
# line 847 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = DIRECTION;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 94:
# line 858 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.c.g = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 95:
# line 867 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = yyval.y_det->u.c.g = yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 96:
# line 874 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 97:
# line 881 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 98:
# line 890 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 99:
# line 900 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 100:
# line 912 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 101:
# line 916 "gram.y"
{
		if (yypvt[-0].y_det->nxt != (details *)NULL)
			yypvt[-0].y_det->nxt->nxt = yypvt[-2].y_det;
		else
			yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 102:
# line 926 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VERTEX;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 103:
# line 935 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 104:
# line 944 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->nxt = (details *)smalloc(sizeof(details));
		yyval.y_det->nxt->type = TRANSPARENCY;
		yyval.y_det->nxt->u.c.r = yyval.y_det->nxt->u.c.g = yyval.y_det->nxt->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt->nxt = (details *)NULL;
	  } break;
case 105:
# line 958 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ROTATE;
		yyval.y_det->u.rot.ang = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.rot.axis = eval_iexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 106:
# line 966 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSLATE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 107:
# line 975 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 108:
# line 987 "gram.y"
{
		matrix	m;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSFORM;

		mident4(m);

		m[0][0] = eval_fexpr(yypvt[-23].y_exp);
		m[0][1] = eval_fexpr(yypvt[-21].y_exp);
		m[0][2] = eval_fexpr(yypvt[-19].y_exp);

		m[1][0] = eval_fexpr(yypvt[-17].y_exp);
		m[1][1] = eval_fexpr(yypvt[-15].y_exp);
		m[1][2] = eval_fexpr(yypvt[-13].y_exp);

		m[2][0] = eval_fexpr(yypvt[-11].y_exp);
		m[2][1] = eval_fexpr(yypvt[-9].y_exp);
		m[2][2] = eval_fexpr(yypvt[-7].y_exp);

		m[3][0] = eval_fexpr(yypvt[-5].y_exp);
		m[3][1] = eval_fexpr(yypvt[-3].y_exp);
		m[3][2] = eval_fexpr(yypvt[-1].y_exp);

		yyval.y_det->u.trans.m = (matrix *)smalloc(sizeof(matrix));

		minv4(*yyval.y_det->u.trans.m, m);

		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 109:
# line 1020 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 110:
# line 1024 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 111:
# line 1029 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 112:
# line 1036 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MAP;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 113:
# line 1043 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.cm = mapinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
          } break;
case 114:
# line 1050 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLEND;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 115:
# line 1057 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RANGE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 116:
# line 1064 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLENDCOLOR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 117:
# line 1073 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 118:
# line 1081 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTORS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 119:
# line 1090 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTOR;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 120:
# line 1097 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VORTFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 121:
# line 1104 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TURBULENCE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 122:
# line 1111 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SQUEEZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 123:
# line 1118 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = SOURCE;
                yyval.y_det->u.w = waveinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 124:
# line 1125 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPSIZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 125:
# line 1132 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPCOLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 126:
# line 1141 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLOCKSIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 127:
# line 1152 "gram.y"
{
		yyval.y_det = (details *)NULL;
	} break;
case 128:
# line 1156 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	} break;
case 129:
# line 1163 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 130:
# line 1173 "gram.y"
{
                yyval.y_det = (details *)NULL;
          } break;
case 131:
# line 1177 "gram.y"
{
                yypvt[-0].y_det->nxt = yypvt[-1].y_det;
                yyval.y_det = yypvt[-0].y_det;
          } break;
case 132:
# line 1184 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = CENTER;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 133:
# line 1193 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = WAVELENGTH;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 134:
# line 1200 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = AMPLITUDE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 135:
# line 1207 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = PHASE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 136:
# line 1214 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = DAMPING;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 137:
# line 1224 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 138:
# line 1228 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 139:
# line 1233 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 140:
# line 1238 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 141:
# line 1245 "gram.y"
{
		defobj(yypvt[-3].y_str, yypvt[-4].y_sym->type, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 142:
# line 1255 "gram.y"
{
		ostackp++;
		*ostackp = (symbol *)NULL;
	  } break;
case 143:
# line 1260 "gram.y"
{
		details	*d;

		ostackp--;

		d = (details *)smalloc(sizeof(details));

		d->type = yypvt[-1].y_csg->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		defobj(yypvt[-5].y_str, CSG_OBJ, d);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-5].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 144:
# line 1281 "gram.y"
{
		defobj(yypvt[-3].y_str, COMP_OBJ, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 145:
# line 1294 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = OBJECT;
		yyval.y_csg->u.sym = yypvt[-0].y_sym;
	  } break;
case 146:
# line 1300 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_ADD;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 147:
# line 1307 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_INT;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 148:
# line 1314 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_SUB;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 149:
# line 1321 "gram.y"
{
		yyval.y_csg = yypvt[-1].y_csg;
	  } break;
case 150:
# line 1325 "gram.y"
{
		char	buf[BUFSIZ];

		sprintf(buf, "art: object %s not defined.\n", yypvt[-0].y_str);
		fatal(buf);
	  } break;
case 151:
# line 1334 "gram.y"
{
		yyval.y_trm = yypvt[-0].y_trm;
	  } break;
case 152:
# line 1338 "gram.y"
{
		term	*t, *p, *np, *prod;

		prod = (term *)NULL;
		for (p = yypvt[-1].y_trm; p != (term *)NULL; p = p->nxt) {
			for (np = yypvt[-0].y_trm; np != (term *)NULL; np = np->nxt) {
				t = (term *)smalloc(sizeof(term));
				*t = *np;
				t->coef *= p->coef;
				t->xp += p->xp;
				t->yp += p->yp;
				t->zp += p->zp;
				t->nxt = prod;
				prod = t;
			}
		}

		for (t = yypvt[-1].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		for (t = yypvt[-0].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 153:
# line 1368 "gram.y"
{
		yyval.y_trm = yypvt[-1].y_trm;
	  } break;
case 154:
# line 1372 "gram.y"
{
		term	*t, *p, *np, *prod, *nprod;
		int	i, power;

		prod = yypvt[-5].y_trm;
		power = eval_iexpr(yypvt[-1].y_exp);

		for (i = 1; i != power; i++) {		
			nprod = (term *)NULL;
			for (p = yypvt[-5].y_trm; p != (term *)NULL; p = p->nxt) {
				for (np = prod; np != (term *)NULL; np = np->nxt) {
					t = (term *)smalloc(sizeof(term));
					*t = *np;
					t->coef *= p->coef;
					t->xp += p->xp;
					t->yp += p->yp;
					t->zp += p->zp;
					t->nxt = nprod;
					nprod = t;
				}
			}
			if (prod != yypvt[-5].y_trm)
				for (t = prod; t != (term *)NULL; t = np) {
					np = t->nxt;
					free(t);
				}
			prod = nprod;
		}

		for (t = yypvt[-5].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 155:
# line 1409 "gram.y"
{
		term	*p;

		for (p = yypvt[-0].y_trm; p->nxt != (term *)NULL; p = p->nxt)
			;
		yyval.y_trm = yypvt[-0].y_trm;
		p->nxt = yypvt[-2].y_trm;
	  } break;
case 156:
# line 1418 "gram.y"
{
		term	*p, *lp;

		for (p = yypvt[-0].y_trm; p != (term *)NULL; p = p->nxt) {
			p->coef *= -1.0;
			lp = p;
		}

		yyval.y_trm = yypvt[-0].y_trm;
		lp->nxt = yypvt[-2].y_trm;
	  } break;
case 157:
# line 1432 "gram.y"
{
		char	*p;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		for (p = yypvt[-0].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}
	  } break;
case 158:
# line 1458 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_flt;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 159:
# line 1467 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_int;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 160:
# line 1476 "gram.y"
{
		char	*p;
		int	power;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		power = eval_iexpr(yypvt[-1].y_exp);

		for (p = yypvt[-4].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}

		p--;

		switch (*p) {
		case 'x':
			yyval.y_trm->xp += power - 1;
			break;
		case 'y':
			yyval.y_trm->yp += power - 1;
			break;
		case 'z':
			yyval.y_trm->zp += power - 1;
			break;
		default:
			fatal("art: illegal name in equation.\n");
		}
	  } break;
case 161:
# line 1523 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_FLOAT;
		yyval.y_exp->u.f = yypvt[-0].y_flt;
	  } break;
case 162:
# line 1529 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = yypvt[-0].y_int;
	  } break;
case 163:
# line 1535 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = frameno;
	  } break;
case 164:
# line 1541 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = *yypvt[-1].y_str;
		free(yypvt[-1].y_str);
	  } break;
case 165:
# line 1548 "gram.y"
{
		yyval.y_exp = get_varexpr(yypvt[-0].y_str);
	  } break;
case 166:
# line 1552 "gram.y"
{
		yyval.y_exp = get_expr(EXP_ADD, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 167:
# line 1556 "gram.y"
{
		yyval.y_exp = get_expr(EXP_SUB, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 168:
# line 1560 "gram.y"
{
		yyval.y_exp = get_expr(EXP_MUL, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 169:
# line 1564 "gram.y"
{
		yyval.y_exp = get_expr(EXP_DIV, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 170:
# line 1568 "gram.y"
{
		yyval.y_exp = get_expr(EXP_UMINUS, yypvt[-0].y_exp, (expression *)NULL);
	  } break;
	}
	goto yystack;		/* reset registers in driver code */
}
